## liblc3 1.0.1

=== Makefile ===
#
# Copyright 2022 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

V ?= @

BUILD_DIR := build
BIN_DIR := bin


#
# Set `gcc` as default compiler
#

CC := $(if $(CC)=cc,gcc,$(CC))
AS := $(if $(AS)=as,$(CC),$(AS))
LD := $(if $(LD)=ld,$(CC),$(LD))

CFLAGS := $(if $(DEBUG),-O0 -g,-O3)
CFLAGS += -std=c11 -Wall -Wextra -Wdouble-promotion


#
# Declarations
#

lib_list :=
bin_list :=

define add-lib
    $(eval $(1)_bin ?= $(1).a)
    $(eval $(1)_bin := $(addprefix $(BIN_DIR)/,$($(1)_bin)))

    lib_list += $(1)
    LIB += $($(1)_bin)
endef

define add-bin
    $(eval $(1)_bin ?= $(1))
    $(eval $(1)_bin := $(addprefix $(BIN_DIR)/,$($(1)_bin)))

    $($(1)_bin): LDLIBS += $(if $(filter $(LIBC),bionic),\
      $(filter-out rt pthread,$($(1)_ldlibs)),$($(1)_ldlibs))
    $($(1)_bin): LDFLAGS += $($(1)_ldflags)

    bin_list += $(1)
    BIN += $($(1)_bin)
endef

define set-target
    $(eval $(1)_obj ?= $(patsubst %.c,%.o,$(filter %.c,$($(1)_src))) \
                       $(patsubst %.s,%.o,$(filter %.s,$($(1)_src))))
    $(eval $(1)_obj := $(addprefix $(BUILD_DIR)/,$($(1)_obj)))
    $(eval $(1)_lib := $(foreach lib, $($(1)_lib), $($(lib)_bin)))

    $($(1)_obj): INCLUDE += $($(1)_include)
    $($(1)_obj): DEFINE  += $($(1)_define)
    $($(1)_obj): CFLAGS  += $($(1)_cflags)

    -include $($(1)_obj:.o=.d)

    $($(1)_bin): $($(1)_lib)
    $($(1)_bin): $($(1)_obj)
    $($(1)_bin): $($(1)_dependencies)

    .PHONY: $(1)
    $(1): $($(1)_bin)
endef

.PHONY: default
default:


INCLUDE += include

SRC_DIR = src
include $(SRC_DIR)/makefile.mk

TOOLS_DIR = tools
-include $(TOOLS_DIR)/makefile.mk

TEST_DIR := test
-include $(TEST_DIR)/makefile.mk


#
# Rules
#

MAKEFILE_DEPS := $(MAKEFILE_LIST)

$(foreach lib, $(lib_list), $(eval $(call set-target,$(lib))))
$(foreach bin, $(bin_list), $(eval $(call set-target,$(bin))))

$(BUILD_DIR)/%.o: %.c $(MAKEFILE_DEPS)
	@echo "  CC      $(notdir $<)"
	$(V)mkdir -p $(dir $@)
	$(V)$(CC) $< -c $(CFLAGS) \
	    $(addprefix -I,$(INCLUDE)) \
	    $(addprefix -D,$(DEFINE)) -MMD -MF $(@:.o=.d) -o $@

$(BUILD_DIR)/%.o: %.s $(MAKEFILE_DEPS)
	@echo "  AS      $(notdir $<)"
	$(V)mkdir -p $(dir $@)
	$(V)$(AS) $< -c $(CFLAGS) \
	    $(addprefix -I,$(INCLUDE)) \
	    $(addprefix -D,$(DEFINE)) -MMD -MF $(@:.o=.d) -o $@

$(LIB): $(MAKEFILE_DEPS)
	@echo "  AR      $(notdir $@)"
	$(V)mkdir -p $(dir $@)
	$(V)$(AR) rcs $@ $(filter %.o,$^)

$(BIN): $(MAKEFILE_DEPS)
	@echo "  LD      $(notdir $@)"
	$(V)mkdir -p $(dir $@)
	$(V)$(LD) $(filter %.o,$^) $(filter %.a,$^) $(LDFLAGS) \
	    $(addprefix -l,$(LDLIBS)) -o $@

clean:
	$(V)rm -rf $(BUILD_DIR)
	$(V)rm -rf $(BIN_DIR)

clean-all: clean

=== meson_options.txt ===
#  Copyright © 2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at:
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

option('tools',
    type: 'boolean',
    value: false,
    description: 'Build tools')

=== debian/changelog ===
liblc3 (1.0.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 19 Dec 2022 16:38:42 -0800

liblc3 (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #1021532)

 -- Dylan Aïssi <daissi@debian.org>  Mon, 10 Oct 2022 22:59:57 +0200

=== debian/control ===
Source: liblc3
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13), meson
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/liblc3
Vcs-Git: https://salsa.debian.org/multimedia-team/liblc3.git
Homepage: https://github.com/google/liblc3

Package: liblc3-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Low Complexity Communication Codec (shared library)
 LC3 is an efficient low latency audio codec.
 .
 This package provides the shared library.

Package: liblc3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblc3-0 (= ${binary:Version}), ${misc:Depends}
Description: Low Complexity Communication Codec (development files)
 LC3 is an efficient low latency audio codec.
 .
 This package provides the development files for liblc3.

Package: liblc3-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Low Complexity Communication Codec
 LC3 is an efficient low latency audio codec.
 .
 This package provides encoder and decoder tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dtools=true

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/liblc3-$1\.tar\.gz/ \
  https://github.com/google/liblc3/tags .*/v?(\d\S+)\.tar\.gz

## liblc3 1.0.3

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 LD := $(if $(LD)=ld,$(CC),$(LD))
 
 CFLAGS := $(if $(DEBUG),-O0 -g,-O3)
-CFLAGS += -std=c11 -Wall -Wextra -Wdouble-promotion
+CFLAGS += -std=c11 -Wall -Wextra -Wdouble-promotion -Wvla -pedantic
 
 
 #

=== debian/changelog ===
liblc3 (1.0.3-4) unstable; urgency=medium

  * Restrict autopkgtest to same arches for tests at build time

 -- Dylan Aïssi <daissi@debian.org>  Tue, 27 Jun 2023 09:46:16 +0200

liblc3 (1.0.3-3) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Mon, 26 Jun 2023 09:33:51 +0200

liblc3 (1.0.3-2) experimental; urgency=medium

  * Disable tests on non-key architectures for bluetooth.

 -- Dylan Aïssi <daissi@debian.org>  Fri, 23 Jun 2023 23:34:09 +0200

liblc3 (1.0.3-1) experimental; urgency=medium

  * New upstream version 1.0.3
  * Drop debian/patches/Fix_numpy_int.patch, included in upstream release
  * Add libpython3-dev in Build-Deps for tests at build time

 -- Dylan Aïssi <daissi@debian.org>  Thu, 22 Jun 2023 15:05:44 +0200

liblc3 (1.0.2-1) experimental; urgency=medium

  [ Dylan Aïssi ]
  * New upstream version 1.0.2
  * Drop patches included in upstream release
  * Bump SONAME to liblc3-1
  * Standards-Version: 4.6.2 (no changes needed)
  * Inject FLAGS during the dh_auto_test step
  * Upload to experimental because of the Bookworm freeze

  [ Sebastien Bacher ]
  * debian/control, debian/rules, debian/tests/control:
    - enable the upstream tests during the build and also set them as an
      autopkgtest (Closes: #1024714)

 -- Dylan Aïssi <daissi@debian.org>  Mon, 27 Feb 2023 10:29:33 +0100

=== debian/control ===
Source: liblc3
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               meson,
               libpython3-dev [amd64 arm64 armhf] <!nocheck>,
               python3-numpy [amd64 arm64 armhf] <!nocheck>,
               python3-scipy [amd64 arm64 armhf] <!nocheck>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/liblc3
Vcs-Git: https://salsa.debian.org/multimedia-team/liblc3.git
Homepage: https://github.com/google/liblc3

Package: liblc3-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Low Complexity Communication Codec (shared library)
 LC3 is an efficient low latency audio codec.
 .
 This package provides the shared library.

Package: liblc3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblc3-1 (= ${binary:Version}),
         ${misc:Depends}
Description: Low Complexity Communication Codec (development files)
 LC3 is an efficient low latency audio codec.
 .
 This package provides the development files for liblc3.

Package: liblc3-tools
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Low Complexity Communication Codec
 LC3 is an efficient low latency audio codec.
 .
 This package provides encoder and decoder tools.

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,7 @@
 	dh_auto_configure -- \
 		-Dtools=true
 
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+override_dh_auto_test:
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf))
+	V= make test CFLAGS:="$(CPPFLAGS) $(CFLAGS)"
+endif

## liblc3 1.0.4

=== debian/changelog ===
liblc3 (1.0.4-3build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:51:51 +0000

liblc3 (1.0.4-3) unstable; urgency=medium

  * Cherry-pick upstream patch adding numpy include path (Closes: #1067323)
  * Refresh debian/copyright
  * Add debian/upstream/metadata

 -- Dylan Aïssi <daissi@debian.org>  Sat, 23 Mar 2024 22:22:25 +0100

liblc3 (1.0.4-2) unstable; urgency=medium

  * Empty the V variable for the "make clean" target (Closes: #1056142)

 -- Dylan Aïssi <daissi@debian.org>  Thu, 23 Nov 2023 12:07:17 +0100

liblc3 (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
  * Delete more files with dh_clean and dh_auto_clean (Closes: #1047907)

 -- Dylan Aïssi <daissi@debian.org>  Sat, 23 Sep 2023 16:29:36 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: liblc3
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Dylan Aïssi <daissi@debian.org>
 Build-Depends: debhelper-compat (= 13),
                meson,

=== debian/rules ===
--- 
+++ 
@@ -13,3 +13,6 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf))
 	V= make test CFLAGS:="$(CPPFLAGS) $(CFLAGS)"
 endif
+
+execute_after_dh_auto_clean:
+	V= make clean

=== debian/tests/control ===
Test-Command: dh_auto_configure; dh_auto_build; dh_auto_test
Depends: @builddeps@
Restrictions: allow-stderr
Architecture: amd64 arm64 armhf

## liblc3 1.1.1+dfsg

=== debian/changelog ===
liblc3 (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.1+dfsg
  * Update symbols file
  * Add patch fixing issue with rpath
  * Exclude conformance HTML reports
  * Fix LDFLAGS injection during dh_auto_test

 -- Dylan Aïssi <daissi@debian.org>  Mon, 20 May 2024 20:50:29 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 override_dh_auto_test:
 ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf))
-	V= make test CFLAGS:="$(CPPFLAGS) $(CFLAGS)"
+	V= make test CFLAGS:="$(CPPFLAGS) $(CFLAGS)" LDFLAGS:="$(LDFLAGS)"
 endif
 
 execute_after_dh_auto_clean:

## liblc3 1.1.2+dfsg

=== debian/changelog ===
liblc3 (1.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.2+dfsg
  * Ensure the build profil nocheck is respected
  * Add salsa-ci-yml
  * Update debian/copyright

 -- Dylan Aïssi <daissi@debian.org>  Wed, 05 Feb 2025 18:24:43 +0100

## liblc3 1.1.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -28,8 +28,30 @@
 AS := $(if $(AS)=as,$(CC),$(AS))
 LD := $(if $(LD)=ld,$(CC),$(LD))
 
-CFLAGS := $(if $(DEBUG),-O0 -g,-O3)
+CFLAGS  := $(if $(DEBUG),-O0 -g,-O3)
+LDFLAGS := $(if $(DEBUG),-O0 -g,-O3)
+
 CFLAGS += -std=c11 -Wall -Wextra -Wdouble-promotion -Wvla -pedantic
+
+TARGET = $(lastword $(shell $(CC) -v 2>&1 | grep "Target: "))
+
+LIB_SHARED := true
+LIB_SUFFIX := so
+
+ifeq ($(TARGET),wasm32)
+  LIB_SHARED := false
+  LIB_SUFFIX := wasm
+  CFLAGS += -Iwasm -mbulk-memory
+  LDFLAGS += -nostdlib -Wl,--no-entry -Wl,--export-dynamic
+endif
+
+ifneq ($(LC3_PLUS),)
+  DEFINE += LC3_PLUS=$(LC3_PLUS)
+endif
+
+ifneq ($(LC3_PLUS_HR),)
+  DEFINE += LC3_PLUS_HR=$(LC3_PLUS_HR)
+endif
 
 
 #
@@ -40,7 +62,7 @@
 bin_list :=
 
 define add-lib
-    $(eval $(1)_bin ?= $(1).a)
+    $(eval $(1)_bin ?= $(1).$(LIB_SUFFIX))
     $(eval $(1)_bin := $(addprefix $(BIN_DIR)/,$($(1)_bin)))
 
     lib_list += $(1)
@@ -61,17 +83,17 @@
 
 define set-target
     $(eval $(1)_obj ?= $(patsubst %.c,%.o,$(filter %.c,$($(1)_src))) \
-                       $(patsubst %.s,%.o,$(filter %.s,$($(1)_src))))
+                       $(patsubst %.s,%.o,$(filter %.s,$($(1)_src))) \
+                       $(patsubst %.cc,%.o,$(filter %.cc,$($(1)_src))))
     $(eval $(1)_obj := $(addprefix $(BUILD_DIR)/,$($(1)_obj)))
-    $(eval $(1)_lib := $(foreach lib, $($(1)_lib), $($(lib)_bin)))
 
-    $($(1)_obj): INCLUDE += $($(1)_include)
-    $($(1)_obj): DEFINE  += $($(1)_define)
-    $($(1)_obj): CFLAGS  += $($(1)_cflags)
+    $($(1)_obj): INCLUDE  += $($(1)_include)
+    $($(1)_obj): DEFINE   += $($(1)_define)
+    $($(1)_obj): CFLAGS   += $($(1)_cflags)
+    $($(1)_obj): CXXFLAGS += $($(1)_cxxflags)
 
     -include $($(1)_obj:.o=.d)
 
-    $($(1)_bin): $($(1)_lib)
     $($(1)_bin): $($(1)_obj)
     $($(1)_bin): $($(1)_dependencies)
 
@@ -93,6 +115,9 @@
 
 TEST_DIR := test
 -include $(TEST_DIR)/makefile.mk
+
+FUZZ_DIR := fuzz
+-include $(FUZZ_DIR)/makefile.mk
 
 
 #
@@ -118,16 +143,28 @@
 	    $(addprefix -I,$(INCLUDE)) \
 	    $(addprefix -D,$(DEFINE)) -MMD -MF $(@:.o=.d) -o $@
 
+$(BUILD_DIR)/%.o: %.cc $(MAKEFILE_DEPS)
+	@echo "  CXX     $(notdir $<)"
+	$(V)mkdir -p $(dir $@)
+	$(V)$(CXX) $< -c $(CXXFLAGS) \
+	    $(addprefix -I,$(INCLUDE)) \
+	    $(addprefix -D,$(DEFINE)) -MMD -MF $(@:.o=.d) -o $@
+
+ifeq ($(LIB_SHARED),true)
+    $(LIB): CFLAGS += -fvisibility=hidden -flto -fPIC
+    $(LIB): LDFLAGS += -flto -shared
+endif
+
 $(LIB): $(MAKEFILE_DEPS)
-	@echo "  AR      $(notdir $@)"
+	@echo "  LD      $(notdir $@)"
 	$(V)mkdir -p $(dir $@)
-	$(V)$(AR) rcs $@ $(filter %.o,$^)
+	$(V)$(LD) $(filter %.o,$^) $(LDFLAGS) -o $@
 
 $(BIN): $(MAKEFILE_DEPS)
 	@echo "  LD      $(notdir $@)"
 	$(V)mkdir -p $(dir $@)
-	$(V)$(LD) $(filter %.o,$^) $(filter %.a,$^) $(LDFLAGS) \
-	    $(addprefix -l,$(LDLIBS)) -o $@
+	$(V)$(LD) $(filter %.o,$^) \
+	    $(LDFLAGS) -L $(BIN_DIR) $(addprefix -l,$(LDLIBS)) -o $@
 
 clean:
 	$(V)rm -rf $(BUILD_DIR)

=== debian/changelog ===
liblc3 (1.1.3+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.3+dfsg

 -- Dylan Aïssi <daissi@debian.org>  Tue, 18 Feb 2025 15:42:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: liblc3
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Dylan Aïssi <daissi@debian.org>
 Build-Depends: debhelper-compat (= 13),
                meson,
                libpython3-dev [amd64 arm64 armhf] <!nocheck>,
                python3-numpy [amd64 arm64 armhf] <!nocheck>,
                python3-scipy [amd64 arm64 armhf] <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/multimedia-team/liblc3
 Vcs-Git: https://salsa.debian.org/multimedia-team/liblc3.git

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,10 @@
 		-Dtools=true
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf))
 	V= make test CFLAGS:="$(CPPFLAGS) $(CFLAGS)" LDFLAGS:="$(LDFLAGS)"
+endif
 endif
 
 execute_after_dh_auto_clean:

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/liblc3-$1\.tar\.gz/" \
  https://github.com/google/liblc3/tags .*/v?(\d\S+)\.tar\.gz
